diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/dsr/model/dsr-routing.cc ns-3.41/src/dsr/model/dsr-routing.cc
--- ns-3.40/src/dsr/model/dsr-routing.cc	2023-09-27 13:30:37.642839000 -0700
+++ ns-3.41/src/dsr/model/dsr-routing.cc	2024-02-09 14:44:07.901790100 -0800
@@ -927,7 +927,7 @@
                     {
                         m_routeCache->UseExtends(errorRoute);
                     }
-                    sourceRoute.SetSegmentsLeft((errorRoute.size() - 2));
+                    sourceRoute.SetSegmentsLeft(errorRoute.size() - 2);
                     uint8_t salvage = 0;
                     sourceRoute.SetSalvage(salvage);
                     Ipv4Address nextHop =
@@ -1000,12 +1000,12 @@
                     return;
                 }
                 uint8_t salvage = 0;
-                sourceRoute.SetNodesAddress(
-                    nodeList); // Save the whole route in the source route header of the packet
-                sourceRoute.SetSegmentsLeft(
-                    (nodeList.size() - 2)); // The segmentsLeft field will indicate the hops to go
+                // Save the whole route in the source route header of the packet
+                sourceRoute.SetNodesAddress(nodeList);
+                // The segmentsLeft field will indicate the hops to go
+                sourceRoute.SetSegmentsLeft(nodeList.size() - 2);
                 sourceRoute.SetSalvage(salvage);
-                /// When found a route and use it, UseExtends to the link cache
+                // When found a route and use it, UseExtends to the link cache
                 if (m_routeCache->IsLinkCache())
                 {
                     m_routeCache->UseExtends(nodeList);
@@ -1273,8 +1273,8 @@
         {
             m_routeCache->UseExtends(nodeList);
         }
-        sourceRoute.SetSegmentsLeft(
-            (nodeList.size() - 2)); // The segmentsLeft field will indicate the hops to go
+        // The segmentsLeft field will indicate the hops to go
+        sourceRoute.SetSegmentsLeft(nodeList.size() - 2);
         sourceRoute.SetSalvage(salvage);
 
         uint8_t length = sourceRoute.GetLength();
@@ -1431,7 +1431,7 @@
         {
             m_routeCache->UseExtends(nodeList);
         }
-        sourceRoute.SetSegmentsLeft((nodeList.size() - 2));
+        sourceRoute.SetSegmentsLeft(nodeList.size() - 2);
         uint8_t srLength = sourceRoute.GetLength();
         uint8_t length = (srLength + rerrLength);
 
@@ -1600,8 +1600,8 @@
             {
                 m_routeCache->UseExtends(nodeList);
             }
-            sourceRoute.SetSegmentsLeft(
-                (nodeList.size() - 2)); // The segmentsLeft field will indicate the hops to go
+            // The segmentsLeft field will indicate the hops to go
+            sourceRoute.SetSegmentsLeft(nodeList.size() - 2);
             sourceRoute.SetSalvage(salvage);
 
             uint8_t length = sourceRoute.GetLength();
@@ -2491,10 +2491,10 @@
         salvage++;
         DsrOptionSRHeader sourceRoute;
         sourceRoute.SetSalvage(salvage);
-        sourceRoute.SetNodesAddress(
-            nodeList); // Save the whole route in the source route header of the packet
-        sourceRoute.SetSegmentsLeft(
-            (nodeList.size() - 2)); // The segmentsLeft field will indicate the hops to go
+        // Save the whole route in the source route header of the packet
+        sourceRoute.SetNodesAddress(nodeList);
+        // The segmentsLeft field will indicate the hops to go
+        sourceRoute.SetSegmentsLeft(nodeList.size() - 2);
         /// When found a route and use it, UseExtends to the link cache
         if (m_routeCache->IsLinkCache())
         {
@@ -3000,7 +3000,7 @@
         {
             m_routeCache->UseExtends(ip);
         }
-        sourceRoute.SetSegmentsLeft((ip.size() - 2));
+        sourceRoute.SetSegmentsLeft(ip.size() - 2);
         sourceRoute.SetSalvage(salvage);
         Ipv4Address nextHop = SearchNextHop(m_mainAddress, ip); // Get the next hop address
         NS_LOG_DEBUG("The nextHop address " << nextHop);
@@ -3237,7 +3237,7 @@
         {
             m_routeCache->UseExtends(ip);
         }
-        sourceRoute.SetSegmentsLeft((ip.size() - 2));
+        sourceRoute.SetSegmentsLeft(ip.size() - 2);
         /// Set the salvage value to 0
         sourceRoute.SetSalvage(0);
         Ipv4Address nextHop = SearchNextHop(m_mainAddress, ip); // Get the next hop address
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/energy/examples/basic-energy-model-test.cc ns-3.41/src/energy/examples/basic-energy-model-test.cc
--- ns-3.40/src/energy/examples/basic-energy-model-test.cc	2023-09-27 13:30:37.642839000 -0700
+++ ns-3.41/src/energy/examples/basic-energy-model-test.cc	2024-02-09 14:44:07.905790000 -0800
@@ -145,7 +145,7 @@
     // retrieve device energy model from energy source
     DeviceEnergyModelContainer models = source->FindDeviceEnergyModels("ns3::WifiRadioEnergyModel");
     // check list
-    if ((models.GetN() == 0))
+    if (models.GetN() == 0)
     {
         std::cerr << "Model list is empty!." << std::endl;
         return true;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/energy/examples/CMakeLists.txt ns-3.41/src/energy/examples/CMakeLists.txt
--- ns-3.40/src/energy/examples/CMakeLists.txt	2023-09-27 13:30:37.642839000 -0700
+++ ns-3.41/src/energy/examples/CMakeLists.txt	2024-02-09 14:44:07.905790000 -0800
@@ -5,7 +5,7 @@
                     ${libenergy}
 )
 
-build_example(
+build_lib_example(
   NAME generic-battery-wifiradio-example
   SOURCE_FILES generic-battery-wifiradio-example.cc
   LIBRARIES_TO_LINK
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/energy/examples/generic-battery-discharge-example.py ns-3.41/src/energy/examples/generic-battery-discharge-example.py
--- ns-3.40/src/energy/examples/generic-battery-discharge-example.py	2023-09-27 13:30:37.642839000 -0700
+++ ns-3.41/src/energy/examples/generic-battery-discharge-example.py	2024-02-09 14:44:07.905790000 -0800
@@ -20,7 +20,15 @@
 #  Demonstrates the discharge behavior of a NIMH battery discharged with a
 #  constant current of 6.5 A (1C)
 
-from ns import ns
+try:
+    from ns import ns
+except ModuleNotFoundError:
+    raise SystemExit(
+        "Error: ns3 Python module not found;"
+        " Python bindings may not be enabled"
+        " or your PYTHONPATH might not be properly configured"
+    )
+
 
 def main(argv):
     """The main function in this Battery discharge example
@@ -32,7 +40,7 @@
     ns.core.LogComponentEnable("GenericBatteryModel", ns.core.LOG_LEVEL_DEBUG)
 
     node = ns.network.Node()
-    batteryHelper =  ns.energy.GenericBatteryModelHelper()
+    batteryHelper = ns.energy.GenericBatteryModelHelper()
     batteryModel = ns.CreateObject("GenericBatteryModel")
     devicesEnergyModel = ns.energy.SimpleDeviceEnergyModel()
 
@@ -40,14 +48,14 @@
     batteryModel.SetAttribute("MaxCapacity", ns.core.DoubleValue(7.0))  # Q
 
     batteryModel.SetAttribute("NominalVoltage", ns.core.DoubleValue(1.18))  # Vnom
-    batteryModel.SetAttribute("NominalCapacity", ns.core.DoubleValue(6.25)) # QNom
+    batteryModel.SetAttribute("NominalCapacity", ns.core.DoubleValue(6.25))  # QNom
 
-    batteryModel.SetAttribute("ExponentialVoltage", ns.core.DoubleValue(1.28)) # Vexp
-    batteryModel.SetAttribute("ExponentialCapacity", ns.core.DoubleValue(1.3)) # Qexp
+    batteryModel.SetAttribute("ExponentialVoltage", ns.core.DoubleValue(1.28))  # Vexp
+    batteryModel.SetAttribute("ExponentialCapacity", ns.core.DoubleValue(1.3))  # Qexp
 
-    batteryModel.SetAttribute("InternalResistance", ns.core.DoubleValue(0.0046))   # R
-    batteryModel.SetAttribute("TypicalDischargeCurrent", ns.core.DoubleValue(1.3)) # i typical
-    batteryModel.SetAttribute("CutoffVoltage", ns.core.DoubleValue(1.0))   # End of charge.
+    batteryModel.SetAttribute("InternalResistance", ns.core.DoubleValue(0.0046))  # R
+    batteryModel.SetAttribute("TypicalDischargeCurrent", ns.core.DoubleValue(1.3))  # i typical
+    batteryModel.SetAttribute("CutoffVoltage", ns.core.DoubleValue(1.0))  # End of charge.
 
     batteryModel.SetAttribute("BatteryType", ns.core.EnumValue(ns.NIMH_NICD))  # Battery type
 
@@ -57,14 +65,12 @@
 
     devicesEnergyModel.SetCurrentA(6.5)
 
-
     ns.core.Simulator.Stop(ns.core.Seconds(3600))
     ns.core.Simulator.Run()
     ns.core.Simulator.Destroy()
 
 
-
-if __name__ == '__main__':
+if __name__ == "__main__":
     import sys
-    main(sys.argv)
 
+    main(sys.argv)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/energy/model/generic-battery-model.cc ns-3.41/src/energy/model/generic-battery-model.cc
--- ns-3.40/src/energy/model/generic-battery-model.cc	2023-09-27 13:30:37.642839000 -0700
+++ ns-3.41/src/energy/model/generic-battery-model.cc	2024-02-09 14:44:07.905790000 -0800
@@ -104,7 +104,7 @@
             .AddAttribute("BatteryType",
                           "Indicates the battery type used by the model",
                           EnumValue(LION_LIPO),
-                          MakeEnumAccessor(&GenericBatteryModel::m_batteryType),
+                          MakeEnumAccessor<GenericBatteryType>(&GenericBatteryModel::m_batteryType),
                           MakeEnumChecker(LION_LIPO,
                                           "LION_LIPO",
                                           NIMH_NICD,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/energy/model/li-ion-energy-source.h ns-3.41/src/energy/model/li-ion-energy-source.h
--- ns-3.40/src/energy/model/li-ion-energy-source.h	2023-09-27 13:30:37.642839000 -0700
+++ ns-3.41/src/energy/model/li-ion-energy-source.h	2024-02-09 14:44:07.905790000 -0800
@@ -22,6 +22,7 @@
 
 #include "energy-source.h"
 
+#include "ns3/deprecated.h"
 #include "ns3/event-id.h"
 #include "ns3/nstime.h"
 #include "ns3/traced-value.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/fd-net-device/CMakeLists.txt ns-3.41/src/fd-net-device/CMakeLists.txt
--- ns-3.40/src/fd-net-device/CMakeLists.txt	2023-09-27 13:30:37.642839000 -0700
+++ ns-3.41/src/fd-net-device/CMakeLists.txt	2024-02-09 14:44:07.909790000 -0800
@@ -26,6 +26,9 @@
 )
 
 include(FindPkgConfig)
+set(DPDK_INCLUDE_DIRS
+    ""
+)
 if(PKG_CONFIG_FOUND)
   pkg_check_modules(
     DPDK
@@ -137,6 +140,8 @@
     FdNetDevice
   )
 
+  set(emu_sources)
+  set(emu_headers)
   if(${ENABLE_EMUNETDEV})
     set(emu_sources
         helper/emu-fd-net-device-helper.cc
@@ -172,6 +177,8 @@
     )
   endif()
 
+  set(tap_sources)
+  set(tap_headers)
   if(${ENABLE_TAPNETDEV})
     set(tap_sources
         helper/tap-fd-net-device-helper.cc
@@ -190,6 +197,7 @@
         helper/creator-utils.cc
         helper/encode-decode.cc
         helper/tap-device-creator.cc
+      LIBRARIES_TO_LINK ${libnetwork}
       EXECUTABLE_DIRECTORY_PATH
         ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/src/fd-net-device/
       INSTALL_DIRECTORY_PATH ${CMAKE_INSTALL_LIBEXECDIR}/ns3
@@ -208,6 +216,8 @@
     )
   endif()
 
+  set(netmap_sources)
+  set(netmap_headers)
   if(${ENABLE_NETMAP_EMU})
     set(netmap_sources
         helper/netmap-net-device-helper.cc
@@ -241,6 +251,9 @@
     )
   endif()
 
+  set(dpdk_sources)
+  set(dpdk_headers)
+  set(dpdk_libraries)
   if(${ENABLE_DPDKDEVNET})
     set(dpdk_sources
         model/dpdk-net-device.cc
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/fd-net-device/examples/realtime-fd2fd-onoff.cc ns-3.41/src/fd-net-device/examples/realtime-fd2fd-onoff.cc
--- ns-3.40/src/fd-net-device/examples/realtime-fd2fd-onoff.cc	2023-09-27 13:30:37.646839100 -0700
+++ ns-3.41/src/fd-net-device/examples/realtime-fd2fd-onoff.cc	2024-02-09 14:44:07.909790000 -0800
@@ -28,10 +28,10 @@
 //  |  fd-net-device |--------------|  fd-net-device |
 //  +----------------+              +----------------+
 //
-// This example is aimed at measuring the thoughput of the FdNetDevice
+// This example is aimed at measuring the throughput of the FdNetDevice
 // in a pure simulation. For this purpose two FdNetDevices, attached to
 // different nodes but in a same simulation, are connected using a socket pair.
-// TCP traffic is sent at a saturating data rate. Then the thoughput can
+// TCP traffic is sent at a saturating data rate. Then the throughput can
 // be obtained from the generated .pcap files.
 //
 // Steps to run the experiment:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/fd-net-device/helper/tap-device-creator.cc ns-3.41/src/fd-net-device/helper/tap-device-creator.cc
--- ns-3.40/src/fd-net-device/helper/tap-device-creator.cc	2023-09-27 13:30:37.646839100 -0700
+++ ns-3.41/src/fd-net-device/helper/tap-device-creator.cc	2024-02-09 14:44:07.909790000 -0800
@@ -17,6 +17,8 @@
 
 #include "creator-utils.h"
 
+#include "ns3/mac48-address.h"
+
 #include <arpa/inet.h>
 #include <cstring>
 #include <errno.h>
@@ -38,18 +40,6 @@
 
 #define TAP_MAGIC 95549
 
-//
-// Lots of the following helper code taken from corresponding functions in src/node.
-//
-#define ASCII_DOT (0x2e)
-#define ASCII_ZERO (0x30)
-#define ASCII_a (0x41)
-#define ASCII_z (0x5a)
-#define ASCII_A (0x61)
-#define ASCII_Z (0x7a)
-#define ASCII_COLON (0x3a)
-#define ASCII_ZERO (0x30)
-
 using namespace ns3;
 
 /**
@@ -62,54 +52,6 @@
     int32_t ifr6_ifindex;      //!< interface index
 };
 
-char
-AsciiToLowCase(char c)
-{
-    if (c >= ASCII_a && c <= ASCII_z)
-    {
-        return c;
-    }
-    else if (c >= ASCII_A && c <= ASCII_Z)
-    {
-        return c + (ASCII_a - ASCII_A);
-    }
-    else
-    {
-        return c;
-    }
-}
-
-void
-AsciiToMac48(const char* str, uint8_t addr[6])
-{
-    int i = 0;
-    while (*str != 0 && i < 6)
-    {
-        uint8_t byte = 0;
-        while (*str != ASCII_COLON && *str != 0)
-        {
-            byte <<= 4;
-            char low = AsciiToLowCase(*str);
-            if (low >= ASCII_a)
-            {
-                byte |= low - ASCII_a + 10;
-            }
-            else
-            {
-                byte |= low - ASCII_ZERO;
-            }
-            str++;
-        }
-        addr[i] = byte;
-        i++;
-        if (*str == 0)
-        {
-            break;
-        }
-        str++;
-    }
-}
-
 void
 SetIpv4(const char* deviceName, const char* ip, const char* netmask)
 {
@@ -189,7 +131,7 @@
     memset(&ifr, 0, sizeof(struct ifreq));
 
     ifr.ifr_hwaddr.sa_family = 1; // this is ARPHRD_ETHER from if_arp.h
-    AsciiToMac48(mac, (uint8_t*)ifr.ifr_hwaddr.sa_data);
+    Mac48Address(mac).CopyTo((uint8_t*)ifr.ifr_hwaddr.sa_data);
     ABORT_IF(ioctl(fd, SIOCSIFHWADDR, &ifr) == -1, "Could not set MAC address", true);
     LOG("Set device MAC address to " << mac);
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/fd-net-device/model/fd-net-device.cc ns-3.41/src/fd-net-device/model/fd-net-device.cc
--- ns-3.40/src/fd-net-device/model/fd-net-device.cc	2023-09-27 13:30:37.646839100 -0700
+++ ns-3.41/src/fd-net-device/model/fd-net-device.cc	2024-02-09 14:44:07.909790000 -0800
@@ -106,7 +106,7 @@
             .AddAttribute("EncapsulationMode",
                           "The link-layer encapsulation type to use.",
                           EnumValue(DIX),
-                          MakeEnumAccessor(&FdNetDevice::m_encapMode),
+                          MakeEnumAccessor<EncapsulationMode>(&FdNetDevice::m_encapMode),
                           MakeEnumChecker(DIX, "Dix", LLC, "Llc", DIXPI, "DixPi"))
             .AddAttribute("RxQueueSize",
                           "Maximum size of the read queue.  "
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/flow-monitor/CMakeLists.txt ns-3.41/src/flow-monitor/CMakeLists.txt
--- ns-3.40/src/flow-monitor/CMakeLists.txt	2023-09-27 13:30:37.646839100 -0700
+++ ns-3.41/src/flow-monitor/CMakeLists.txt	2024-02-09 14:44:07.909790000 -0800
@@ -19,5 +19,4 @@
     model/ipv6-flow-classifier.h
     model/ipv6-flow-probe.h
   LIBRARIES_TO_LINK ${libinternet}
-                    ${libstats}
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/flow-monitor/examples/flowmon-parse-results.py ns-3.41/src/flow-monitor/examples/flowmon-parse-results.py
--- ns-3.40/src/flow-monitor/examples/flowmon-parse-results.py	2023-09-27 13:30:37.646839100 -0700
+++ ns-3.41/src/flow-monitor/examples/flowmon-parse-results.py	2024-02-09 14:44:07.909790000 -0800
@@ -1,18 +1,20 @@
 from __future__ import division
-import sys
+
 import os
+import sys
+
 try:
     from xml.etree import cElementTree as ElementTree
 except ImportError:
     from xml.etree import ElementTree
 
+
 def parse_time_ns(tm):
-    if tm.endswith('ns'):
+    if tm.endswith("ns"):
         return float(tm[:-2])
     raise ValueError(tm)
 
 
-
 ## FiveTuple
 class FiveTuple(object):
     ## class variables
@@ -28,17 +30,19 @@
     #  destination port
     ## @var __slots_
     #  class variable list
-    __slots_ = ['sourceAddress', 'destinationAddress', 'protocol', 'sourcePort', 'destinationPort']
+    __slots_ = ["sourceAddress", "destinationAddress", "protocol", "sourcePort", "destinationPort"]
+
     def __init__(self, el):
-        '''! The initializer.
+        """! The initializer.
         @param self The object pointer.
         @param el The element.
-        '''
-        self.sourceAddress = el.get('sourceAddress')
-        self.destinationAddress = el.get('destinationAddress')
-        self.sourcePort = int(el.get('sourcePort'))
-        self.destinationPort = int(el.get('destinationPort'))
-        self.protocol = int(el.get('protocol'))
+        """
+        self.sourceAddress = el.get("sourceAddress")
+        self.destinationAddress = el.get("destinationAddress")
+        self.sourcePort = int(el.get("sourcePort"))
+        self.destinationPort = int(el.get("destinationPort"))
+        self.protocol = int(el.get("protocol"))
+
 
 ## Histogram
 class Histogram(object):
@@ -47,17 +51,21 @@
     #  histogram bins
     ## @var __slots_
     #  class variable list
-    __slots_ = 'bins', 'nbins', 'number_of_flows'
+    __slots_ = "bins", "nbins", "number_of_flows"
+
     def __init__(self, el=None):
-        '''! The initializer.
+        """! The initializer.
         @param self The object pointer.
         @param el The element.
-        '''
+        """
         self.bins = []
         if el is not None:
-            #self.nbins = int(el.get('nBins'))
-            for bin in el.findall('bin'):
-                self.bins.append( (float(bin.get("start")), float(bin.get("width")), int(bin.get("count"))) )
+            # self.nbins = int(el.get('nBins'))
+            for bin in el.findall("bin"):
+                self.bins.append(
+                    (float(bin.get("start")), float(bin.get("width")), int(bin.get("count")))
+                )
+
 
 ## Flow
 class Flow(object):
@@ -84,46 +92,63 @@
     #  receive duration
     ## @var __slots_
     #  class variable list
-    __slots_ = ['flowId', 'delayMean', 'packetLossRatio', 'rxBitrate', 'txBitrate',
-                'fiveTuple', 'packetSizeMean', 'probe_stats_unsorted',
-                'hopCount', 'flowInterruptionsHistogram', 'rx_duration']
+    __slots_ = [
+        "flowId",
+        "delayMean",
+        "packetLossRatio",
+        "rxBitrate",
+        "txBitrate",
+        "fiveTuple",
+        "packetSizeMean",
+        "probe_stats_unsorted",
+        "hopCount",
+        "flowInterruptionsHistogram",
+        "rx_duration",
+    ]
+
     def __init__(self, flow_el):
-        '''! The initializer.
+        """! The initializer.
         @param self The object pointer.
         @param flow_el The element.
-        '''
-        self.flowId = int(flow_el.get('flowId'))
-        rxPackets = float(flow_el.get('rxPackets'))
-        txPackets = float(flow_el.get('txPackets'))
-
-        tx_duration = (parse_time_ns (flow_el.get('timeLastTxPacket')) - parse_time_ns(flow_el.get('timeFirstTxPacket')))*1e-9
-        rx_duration = (parse_time_ns (flow_el.get('timeLastRxPacket')) - parse_time_ns(flow_el.get('timeFirstRxPacket')))*1e-9
+        """
+        self.flowId = int(flow_el.get("flowId"))
+        rxPackets = float(flow_el.get("rxPackets"))
+        txPackets = float(flow_el.get("txPackets"))
+
+        tx_duration = (
+            parse_time_ns(flow_el.get("timeLastTxPacket"))
+            - parse_time_ns(flow_el.get("timeFirstTxPacket"))
+        ) * 1e-9
+        rx_duration = (
+            parse_time_ns(flow_el.get("timeLastRxPacket"))
+            - parse_time_ns(flow_el.get("timeFirstRxPacket"))
+        ) * 1e-9
         self.rx_duration = rx_duration
         self.probe_stats_unsorted = []
         if rxPackets:
-            self.hopCount = float(flow_el.get('timesForwarded')) / rxPackets + 1
+            self.hopCount = float(flow_el.get("timesForwarded")) / rxPackets + 1
         else:
             self.hopCount = -1000
         if rxPackets:
-            self.delayMean = float(flow_el.get('delaySum')[:-2]) / rxPackets * 1e-9
-            self.packetSizeMean = float(flow_el.get('rxBytes')) / rxPackets
+            self.delayMean = float(flow_el.get("delaySum")[:-2]) / rxPackets * 1e-9
+            self.packetSizeMean = float(flow_el.get("rxBytes")) / rxPackets
         else:
             self.delayMean = None
             self.packetSizeMean = None
         if rx_duration > 0:
-            self.rxBitrate = float(flow_el.get('rxBytes'))*8 / rx_duration
+            self.rxBitrate = float(flow_el.get("rxBytes")) * 8 / rx_duration
         else:
             self.rxBitrate = None
         if tx_duration > 0:
-            self.txBitrate = float(flow_el.get('txBytes'))*8 / tx_duration
+            self.txBitrate = float(flow_el.get("txBytes")) * 8 / tx_duration
         else:
             self.txBitrate = None
-        lost = float(flow_el.get('lostPackets'))
-        #print "rxBytes: %s; txPackets: %s; rxPackets: %s; lostPackets: %s" % (flow_el.get('rxBytes'), txPackets, rxPackets, lost)
+        lost = float(flow_el.get("lostPackets"))
+        # print "rxBytes: %s; txPackets: %s; rxPackets: %s; lostPackets: %s" % (flow_el.get('rxBytes'), txPackets, rxPackets, lost)
         if rxPackets == 0:
             self.packetLossRatio = None
         else:
-            self.packetLossRatio = (lost / (rxPackets + lost))
+            self.packetLossRatio = lost / (rxPackets + lost)
 
         interrupt_hist_elem = flow_el.find("flowInterruptionsHistogram")
         if interrupt_hist_elem is None:
@@ -131,6 +156,7 @@
         else:
             self.flowInterruptionsHistogram = Histogram(interrupt_hist_elem)
 
+
 ## ProbeFlowStats
 class ProbeFlowStats(object):
     ## class variables
@@ -140,7 +166,8 @@
     #  bytes
     ## @var __slots_
     #  class variable list
-    __slots_ = ['probeId', 'packets', 'bytes', 'delayFromFirstProbe']
+    __slots_ = ["probeId", "packets", "bytes", "delayFromFirstProbe"]
+
 
 ## Simulation
 class Simulation(object):
@@ -148,31 +175,33 @@
     ## @var flows
     #  list of flows
     def __init__(self, simulation_el):
-        '''! The initializer.
+        """! The initializer.
         @param self The object pointer.
         @param simulation_el The element.
-        '''
+        """
         self.flows = []
-        FlowClassifier_el, = simulation_el.findall("Ipv4FlowClassifier")
+        (FlowClassifier_el,) = simulation_el.findall("Ipv4FlowClassifier")
         flow_map = {}
         for flow_el in simulation_el.findall("FlowStats/Flow"):
             flow = Flow(flow_el)
             flow_map[flow.flowId] = flow
             self.flows.append(flow)
         for flow_cls in FlowClassifier_el.findall("Flow"):
-            flowId = int(flow_cls.get('flowId'))
+            flowId = int(flow_cls.get("flowId"))
             flow_map[flowId].fiveTuple = FiveTuple(flow_cls)
 
         for probe_elem in simulation_el.findall("FlowProbes/FlowProbe"):
-            probeId = int(probe_elem.get('index'))
+            probeId = int(probe_elem.get("index"))
             for stats in probe_elem.findall("FlowStats"):
-                flowId = int(stats.get('flowId'))
+                flowId = int(stats.get("flowId"))
                 s = ProbeFlowStats()
-                s.packets = int(stats.get('packets'))
-                s.bytes = float(stats.get('bytes'))
+                s.packets = int(stats.get("packets"))
+                s.bytes = float(stats.get("bytes"))
                 s.probeId = probeId
                 if s.packets > 0:
-                    s.delayFromFirstProbe =  parse_time_ns(stats.get('delayFromFirstProbeSum')) / float(s.packets)
+                    s.delayFromFirstProbe = parse_time_ns(
+                        stats.get("delayFromFirstProbeSum")
+                    ) / float(s.packets)
                 else:
                     s.delayFromFirstProbe = 0
                 flow_map[flowId].probe_stats_unsorted.append(s)
@@ -190,38 +219,46 @@
                 level += 1
             if event == "end":
                 level -= 1
-                if level == 0 and elem.tag == 'FlowMonitor':
+                if level == 0 and elem.tag == "FlowMonitor":
                     sim = Simulation(elem)
                     sim_list.append(sim)
-                    elem.clear() # won't need this any more
+                    elem.clear()  # won't need this any more
                     sys.stdout.write(".")
                     sys.stdout.flush()
     print(" done.")
 
-
     for sim in sim_list:
         for flow in sim.flows:
             t = flow.fiveTuple
-            proto = {6: 'TCP', 17: 'UDP'} [t.protocol]
-            print("FlowID: %i (%s %s/%s --> %s/%i)" % \
-                (flow.flowId, proto, t.sourceAddress, t.sourcePort, t.destinationAddress, t.destinationPort))
+            proto = {6: "TCP", 17: "UDP"}[t.protocol]
+            print(
+                "FlowID: %i (%s %s/%s --> %s/%i)"
+                % (
+                    flow.flowId,
+                    proto,
+                    t.sourceAddress,
+                    t.sourcePort,
+                    t.destinationAddress,
+                    t.destinationPort,
+                )
+            )
             if flow.txBitrate is None:
                 print("\tTX bitrate: None")
             else:
-                print("\tTX bitrate: %.2f kbit/s" % (flow.txBitrate*1e-3,))
+                print("\tTX bitrate: %.2f kbit/s" % (flow.txBitrate * 1e-3,))
             if flow.rxBitrate is None:
                 print("\tRX bitrate: None")
             else:
-                print("\tRX bitrate: %.2f kbit/s" % (flow.rxBitrate*1e-3,))
+                print("\tRX bitrate: %.2f kbit/s" % (flow.rxBitrate * 1e-3,))
             if flow.delayMean is None:
                 print("\tMean Delay: None")
             else:
-                print("\tMean Delay: %.2f ms" % (flow.delayMean*1e3,))
+                print("\tMean Delay: %.2f ms" % (flow.delayMean * 1e3,))
             if flow.packetLossRatio is None:
                 print("\tPacket Loss Ratio: None")
             else:
-                print("\tPacket Loss Ratio: %.2f %%" % (flow.packetLossRatio*100))
+                print("\tPacket Loss Ratio: %.2f %%" % (flow.packetLossRatio * 100))
 
 
-if __name__ == '__main__':
+if __name__ == "__main__":
     main(sys.argv)
